Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90	(revision 5098)
@@ -1,53 +1,53 @@
 !$Id$
 MODULE phytrac_mod
-!=================================================================================
-! Interface between the LMDZ physical package and tracer computation.
-! Chemistry modules (INCA, Reprobus or the more specific traclmdz routine)
-! are called from phytrac.
-!
-!======================================================================
-! Auteur(s) FH
-! Objet: Moniteur general des tendances traceurs
-!
-! iflag_vdf_trac : Options for activating transport by vertical diffusion :
-!     1. notmal
-!     0. emission is injected in the first layer only, without diffusion
-!    -1  no emission & no diffusion
-! Modification 2013/07/22 : transformed into a module to pass tendencies to
-!     physics outputs. Additional keys for controling activation of sub processes.
-! Modification R. Pilon 10 octobre 2012 large scale scavenging incloud_scav + bc_scav
-! Modification R. Pilon 01 janvier 2012 transport+scavenging KE scheme : cvltr
-!=================================================================================
-
-!
-! Tracer tendencies, for outputs
-!-------------------------------
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_cl  ! Td couche limite/traceur
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_dec                            !RomP
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_cv  ! Td convection/traceur
-! RomP >>>
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_insc
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_bcscav
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_evapls
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_ls
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_trsp
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_sscav
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_sat
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_uscav
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: qPr,qDi ! concentration tra dans pluie,air descente insaturee
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: qPa,qMel
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: qTrdi,dtrcvMA ! conc traceur descente air insaturee et td convective MA
-! RomP <<<
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_th  ! Td thermique
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_lessi_impa ! Td du lessivage par impaction
-  REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: d_tr_lessi_nucl ! Td du lessivage par nucleation
-  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE   :: qPrls      !jyg: concentration tra dans pluie LS a la surf.
-  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE   :: d_tr_dry ! Td depot sec/traceur (1st layer),ALLOCATABLE,SAVE  jyg
-  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE   :: flux_tr_dry ! depot sec/traceur (surface),ALLOCATABLE,SAVE    jyg
-
-!$OMP THREADPRIVATE(qPa,qMel,qTrdi,dtrcvMA,d_tr_th,d_tr_lessi_impa,d_tr_lessi_nucl)
-!$OMP THREADPRIVATE(d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qPr,qDi)
-!$OMP THREADPRIVATE(d_tr_insc,d_tr_bcscav,d_tr_evapls,d_tr_ls,qPrls)
-!$OMP THREADPRIVATE(d_tr_cl,d_tr_dry,flux_tr_dry,d_tr_dec,d_tr_cv)
+  !=================================================================================
+  ! Interface between the LMDZ physical package and tracer computation.
+  ! Chemistry modules (INCA, Reprobus or the more specific traclmdz routine)
+  ! are called from phytrac.
+  !
+  !======================================================================
+  ! Auteur(s) FH
+  ! Objet: Moniteur general des tendances traceurs
+  !
+  ! iflag_vdf_trac : Options for activating transport by vertical diffusion :
+  !     1. notmal
+  !     0. emission is injected in the first layer only, without diffusion
+  !    -1  no emission & no diffusion
+  ! Modification 2013/07/22 : transformed into a module to pass tendencies to
+  !     physics outputs. Additional keys for controling activation of sub processes.
+  ! Modification R. Pilon 10 octobre 2012 large scale scavenging incloud_scav + bc_scav
+  ! Modification R. Pilon 01 janvier 2012 transport+scavenging KE scheme : cvltr
+  !=================================================================================
+
+  !
+  ! Tracer tendencies, for outputs
+  !-------------------------------
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_cl  ! Td couche limite/traceur
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_dec                            !RomP
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_cv  ! Td convection/traceur
+  ! RomP >>>
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_insc
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_bcscav
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_evapls
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_ls
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_trsp
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_sscav
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_sat
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_uscav
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: qPr, qDi ! concentration tra dans pluie,air descente insaturee
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: qPa, qMel
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: qTrdi, dtrcvMA ! conc traceur descente air insaturee et td convective MA
+  ! RomP <<<
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_th  ! Td thermique
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_lessi_impa ! Td du lessivage par impaction
+  REAL, DIMENSION(:, :, :), ALLOCATABLE, SAVE :: d_tr_lessi_nucl ! Td du lessivage par nucleation
+  REAL, DIMENSION(:, :), ALLOCATABLE, SAVE :: qPrls      !jyg: concentration tra dans pluie LS a la surf.
+  REAL, DIMENSION(:, :), ALLOCATABLE, SAVE :: d_tr_dry ! Td depot sec/traceur (1st layer),ALLOCATABLE,SAVE  jyg
+  REAL, DIMENSION(:, :), ALLOCATABLE, SAVE :: flux_tr_dry ! depot sec/traceur (surface),ALLOCATABLE,SAVE    jyg
+
+  !$OMP THREADPRIVATE(qPa,qMel,qTrdi,dtrcvMA,d_tr_th,d_tr_lessi_impa,d_tr_lessi_nucl)
+  !$OMP THREADPRIVATE(d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qPr,qDi)
+  !$OMP THREADPRIVATE(d_tr_insc,d_tr_bcscav,d_tr_evapls,d_tr_ls,qPrls)
+  !$OMP THREADPRIVATE(d_tr_cl,d_tr_dry,flux_tr_dry,d_tr_dec,d_tr_cv)
 
 CONTAINS
@@ -56,60 +56,60 @@
 
     USE dimphy
-    USE infotrac_phy, ONLY: nbtr, type_trac
-    USE tracco2i_mod, ONLY: tracco2i_init
-    
+    USE infotrac_phy, ONLY : nbtr, type_trac
+    USE tracco2i_mod, ONLY : tracco2i_init
+
     IMPLICIT NONE
 
-    ALLOCATE(d_tr_cl(klon,klev,nbtr),d_tr_dry(klon,nbtr))
-    ALLOCATE(flux_tr_dry(klon,nbtr),d_tr_dec(klon,klev,nbtr),d_tr_cv(klon,klev,nbtr))
-    ALLOCATE(d_tr_insc(klon,klev,nbtr),d_tr_bcscav(klon,klev,nbtr))
-    ALLOCATE(d_tr_evapls(klon,klev,nbtr),d_tr_ls(klon,klev,nbtr))
-    ALLOCATE(qPrls(klon,nbtr),d_tr_trsp(klon,klev,nbtr))
-    ALLOCATE(d_tr_sscav(klon,klev,nbtr),d_tr_sat(klon,klev,nbtr))
-    ALLOCATE(d_tr_uscav(klon,klev,nbtr),qPr(klon,klev,nbtr),qDi(klon,klev,nbtr))
-    ALLOCATE(qPa(klon,klev,nbtr),qMel(klon,klev,nbtr))
-    ALLOCATE(qTrdi(klon,klev,nbtr),dtrcvMA(klon,klev,nbtr))
-    ALLOCATE(d_tr_th(klon,klev,nbtr))
-    ALLOCATE(d_tr_lessi_impa(klon,klev,nbtr),d_tr_lessi_nucl(klon,klev,nbtr))
+    ALLOCATE(d_tr_cl(klon, klev, nbtr), d_tr_dry(klon, nbtr))
+    ALLOCATE(flux_tr_dry(klon, nbtr), d_tr_dec(klon, klev, nbtr), d_tr_cv(klon, klev, nbtr))
+    ALLOCATE(d_tr_insc(klon, klev, nbtr), d_tr_bcscav(klon, klev, nbtr))
+    ALLOCATE(d_tr_evapls(klon, klev, nbtr), d_tr_ls(klon, klev, nbtr))
+    ALLOCATE(qPrls(klon, nbtr), d_tr_trsp(klon, klev, nbtr))
+    ALLOCATE(d_tr_sscav(klon, klev, nbtr), d_tr_sat(klon, klev, nbtr))
+    ALLOCATE(d_tr_uscav(klon, klev, nbtr), qPr(klon, klev, nbtr), qDi(klon, klev, nbtr))
+    ALLOCATE(qPa(klon, klev, nbtr), qMel(klon, klev, nbtr))
+    ALLOCATE(qTrdi(klon, klev, nbtr), dtrcvMA(klon, klev, nbtr))
+    ALLOCATE(d_tr_th(klon, klev, nbtr))
+    ALLOCATE(d_tr_lessi_impa(klon, klev, nbtr), d_tr_lessi_nucl(klon, klev, nbtr))
 
     !===============================================================================
     !    -- Do specific treatment according to chemestry model or local LMDZ tracers
-    !      
+    !
     !===============================================================================
     !   -- CO2 interactif --
-    IF (ANY(type_trac == ['co2i','inco'])) CALL tracco2i_init()
-
-       !   -- type_trac == 'co2i' ! PC 
-       !   -- CO2 interactif --
-       !   -- source is updated with FF and BB emissions 
-       !   -- and net fluxes from ocean and orchidee 
-       !   -- sign convention : positive into the atmosphere
+    IF (ANY(type_trac == ['co2i', 'inco'])) CALL tracco2i_init()
+
+    !   -- type_trac == 'co2i' ! PC
+    !   -- CO2 interactif --
+    !   -- source is updated with FF and BB emissions
+    !   -- and net fluxes from ocean and orchidee
+    !   -- sign convention : positive into the atmosphere
 
   END SUBROUTINE phytrac_init
 
-  SUBROUTINE phytrac(                                 &
-       nstep,     julien,   gmtime,   debutphy,       &
-       lafin,     pdtphys,  u, v,     t_seri,         &
-       paprs,     pplay,    pmfu,     pmfd,           &
-       pen_u,     pde_u,    pen_d,    pde_d,          &
-       cdragh,    coefh,    fm_therm, entr_therm,     &
-       yu1,       yv1,      ftsol,    pctsrf,         &
-       ustar,     u10m,      v10m,                    &
-       wstar,     ale_bl,      ale_wake,              &
-       xlat,      xlon,                               &
-       frac_impa,frac_nucl,beta_fisrt,beta_v1,        &
-       presnivs,  pphis,    pphi,     albsol,         &
-       sh,        ch, rh,   cldfra,   rneb,           &
-       diafra,    cldliq,   itop_con, ibas_con,       &
-       pmflxr,    pmflxs,   prfl,     psfl,           &
-       da,        phi,      mp,       upwd,           &
-       phi2,      d1a,      dam,      sij, wght_cvfd, &   ! RomP +RL
-       wdtrainA,  wdtrainM, sigd,     clw, elij,      &   ! RomP 
-       evap,      ep,       epmlmMm,  eplaMm,         &   ! RomP
-       dnwd,      aerosol_couple,     flxmass_w,      &
-       tau_aero,  piz_aero,  cg_aero, ccm,            &
-       rfname,                                        &
-       d_tr_dyn,                                      &   ! RomP
-       tr_seri, init_source)         
+  SUBROUTINE phytrac(&
+          nstep, julien, gmtime, debutphy, &
+          lafin, pdtphys, u, v, t_seri, &
+          paprs, pplay, pmfu, pmfd, &
+          pen_u, pde_u, pen_d, pde_d, &
+          cdragh, coefh, fm_therm, entr_therm, &
+          yu1, yv1, ftsol, pctsrf, &
+          ustar, u10m, v10m, &
+          wstar, ale_bl, ale_wake, &
+          xlat, xlon, &
+          frac_impa, frac_nucl, beta_fisrt, beta_v1, &
+          presnivs, pphis, pphi, albsol, &
+          sh, ch, rh, cldfra, rneb, &
+          diafra, cldliq, itop_con, ibas_con, &
+          pmflxr, pmflxs, prfl, psfl, &
+          da, phi, mp, upwd, &
+          phi2, d1a, dam, sij, wght_cvfd, &   ! RomP +RL
+          wdtrainA, wdtrainM, sigd, clw, elij, &   ! RomP
+          evap, ep, epmlmMm, eplaMm, &   ! RomP
+          dnwd, aerosol_couple, flxmass_w, &
+          tau_aero, piz_aero, cg_aero, ccm, &
+          rfname, &
+          d_tr_dyn, &   ! RomP
+          tr_seri, init_source)
     !
     !======================================================================
@@ -123,6 +123,6 @@
     USE phys_cal_mod, only : hour
     USE dimphy
-    USE infotrac_phy, ONLY: nbtr, nqCO2, type_trac, conv_flg, pbl_flg
-    USE strings_mod,  ONLY: int2str
+    USE infotrac_phy, ONLY : nbtr, nqCO2, type_trac, conv_flg, pbl_flg
+    USE strings_mod, ONLY : int2str
     USE mod_grid_phy_lmdz
     USE mod_phys_lmdz_para
@@ -132,6 +132,6 @@
     USE tracreprobus_mod
     USE indice_sol_mod
-    USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
-    USE print_control_mod, ONLY: lunout
+    USE mod_phys_lmdz_mpi_data, ONLY : is_mpi_root
+    USE print_control_mod, ONLY : lunout
     USE aero_mod, ONLY : naero_grp
     USE lmdz_thermcell_dq, ONLY : thermcell_dq
@@ -139,19 +139,18 @@
     USE tracco2i_mod
 
-#ifdef CPP_StratAer
     USE traccoag_mod
-    USE phys_local_var_mod, ONLY: mdw
-    USE phys_local_var_mod, ONLY: budg_dep_dry_ocs,   budg_dep_wet_ocs
-    USE phys_local_var_mod, ONLY: budg_dep_dry_so2,   budg_dep_wet_so2
-    USE phys_local_var_mod, ONLY: budg_dep_dry_h2so4, budg_dep_wet_h2so4
-    USE phys_local_var_mod, ONLY: budg_dep_dry_part,  budg_dep_wet_part
-    USE infotrac_phy, ONLY: nbtr_sulgas, id_OCS_strat, id_SO2_strat, id_H2SO4_strat
+    USE phys_local_var_mod, ONLY : mdw
+    USE phys_local_var_mod, ONLY : budg_dep_dry_ocs, budg_dep_wet_ocs
+    USE phys_local_var_mod, ONLY : budg_dep_dry_so2, budg_dep_wet_so2
+    USE phys_local_var_mod, ONLY : budg_dep_dry_h2so4, budg_dep_wet_h2so4
+    USE phys_local_var_mod, ONLY : budg_dep_dry_part, budg_dep_wet_part
+    USE infotrac_phy, ONLY : nbtr_sulgas, id_OCS_strat, id_SO2_strat, id_H2SO4_strat
     USE strataer_nuc_mod, ONLY : tracstrataer_init
     USE aerophys
-#endif
+    USE lmdz_cppkeys_wrapper, ONLY : CPPKEY_STRATAER
+    USE lmdz_yomcst
 
     IMPLICIT NONE
 
-    INCLUDE "YOMCST.h"
     INCLUDE "clesphys.h"
     !==========================================================================
@@ -162,104 +161,104 @@
     !----------------
     !Configuration grille,temps:
-    INTEGER,INTENT(IN) :: nstep      ! Appel physique
-    INTEGER,INTENT(IN) :: julien     ! Jour julien
-    REAL,INTENT(IN)    :: gmtime     ! Heure courante
-    REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)
-    LOGICAL,INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
-    LOGICAL,INTENT(IN) :: lafin      ! le flag de la fin de la physique
-
-    REAL,DIMENSION(klon),INTENT(IN) :: xlat    ! latitudes pour chaque point 
-    REAL,DIMENSION(klon),INTENT(IN) :: xlon    ! longitudes pour chaque point 
-    !
-    !Physique: 
+    INTEGER, INTENT(IN) :: nstep      ! Appel physique
+    INTEGER, INTENT(IN) :: julien     ! Jour julien
+    REAL, INTENT(IN) :: gmtime     ! Heure courante
+    REAL, INTENT(IN) :: pdtphys    ! Pas d'integration pour la physique (seconde)
+    LOGICAL, INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
+    LOGICAL, INTENT(IN) :: lafin      ! le flag de la fin de la physique
+
+    REAL, DIMENSION(klon), INTENT(IN) :: xlat    ! latitudes pour chaque point
+    REAL, DIMENSION(klon), INTENT(IN) :: xlon    ! longitudes pour chaque point
+    !
+    !Physique:
     !--------
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: u       ! variable not used 
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: v       ! variable not used 
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: rh      ! humidite relative
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: ch      ! eau liquide (+ glace si le traceur existe) 
-    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pphi    ! geopotentiel
-    REAL,DIMENSION(klon),INTENT(IN)        :: pphis
-    REAL,DIMENSION(klev),INTENT(IN)        :: presnivs 
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau condensee totale
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldfra  ! fraction nuageuse (tous les nuages)
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: rneb    ! fraction nuageuse (grande echelle)
-    !
-    REAL                                   :: ql_incl ! contenu en eau liquide nuageuse dans le nuage ! ql_incl=oliq/rneb
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: beta_fisrt ! taux de conversion de l'eau cond (de fisrtilp)
-    REAL,DIMENSION(klon,klev),INTENT(out)  :: beta_v1    ! -- (originale version)
-
-    !
-    INTEGER,DIMENSION(klon),INTENT(IN)     :: itop_con
-    INTEGER,DIMENSION(klon),INTENT(IN)     :: ibas_con
-    REAL,DIMENSION(klon),INTENT(IN)        :: albsol  ! albedo surface
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: t_seri  ! Temperature
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: u       ! variable not used
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: v       ! variable not used
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: sh      ! humidite specifique
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: rh      ! humidite relative
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: ch      ! eau liquide (+ glace si le traceur existe)
+    REAL, DIMENSION(klon, klev + 1), INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pphi    ! geopotentiel
+    REAL, DIMENSION(klon), INTENT(IN) :: pphis
+    REAL, DIMENSION(klev), INTENT(IN) :: presnivs
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: cldliq  ! eau condensee totale
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: cldfra  ! fraction nuageuse (tous les nuages)
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: rneb    ! fraction nuageuse (grande echelle)
+    !
+    REAL :: ql_incl ! contenu en eau liquide nuageuse dans le nuage ! ql_incl=oliq/rneb
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: beta_fisrt ! taux de conversion de l'eau cond (de fisrtilp)
+    REAL, DIMENSION(klon, klev), INTENT(out) :: beta_v1    ! -- (originale version)
+
+    !
+    INTEGER, DIMENSION(klon), INTENT(IN) :: itop_con
+    INTEGER, DIMENSION(klon), INTENT(IN) :: ibas_con
+    REAL, DIMENSION(klon), INTENT(IN) :: albsol  ! albedo surface
     !
     !Dynamique
     !--------
-    REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)    :: d_tr_dyn
+    REAL, DIMENSION(klon, klev, nbtr), INTENT(IN) :: d_tr_dyn
     !
     !Convection:
     !----------
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pmfu  ! flux de masse dans le panache montant
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pmfd  ! flux de masse dans le panache descendant
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pen_u ! flux entraine dans le panache montant
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pde_u ! flux detraine dans le panache montant
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pen_d ! flux entraine dans le panache descendant
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pde_d ! flux detraine dans le panache descendant
-
-    !...Tiedke     
-    REAL,DIMENSION(klon,klev+1),INTENT(IN)   :: pmflxr, pmflxs ! Flux precipitant de pluie, neige aux interfaces [convection]
-    REAL,DIMENSION(klon,klev+1),INTENT(IN)   :: prfl, psfl ! Flux precipitant de pluie, neige aux interfaces [large-scale]
-
-    LOGICAL,INTENT(IN)                       :: aerosol_couple
-    REAL,DIMENSION(klon,klev),INTENT(IN)     :: flxmass_w
-    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: tau_aero
-    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: piz_aero
-    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: cg_aero
-    CHARACTER(len=4),DIMENSION(naero_grp),INTENT(IN) :: rfname 
-    REAL,DIMENSION(klon,klev,2),INTENT(IN)   :: ccm 
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pmfu  ! flux de masse dans le panache montant
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pmfd  ! flux de masse dans le panache descendant
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pen_u ! flux entraine dans le panache montant
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pde_u ! flux detraine dans le panache montant
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pen_d ! flux entraine dans le panache descendant
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: pde_d ! flux detraine dans le panache descendant
+
+    !...Tiedke
+    REAL, DIMENSION(klon, klev + 1), INTENT(IN) :: pmflxr, pmflxs ! Flux precipitant de pluie, neige aux interfaces [convection]
+    REAL, DIMENSION(klon, klev + 1), INTENT(IN) :: prfl, psfl ! Flux precipitant de pluie, neige aux interfaces [large-scale]
+
+    LOGICAL, INTENT(IN) :: aerosol_couple
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: flxmass_w
+    REAL, DIMENSION(klon, klev, naero_grp, 2), INTENT(IN) :: tau_aero
+    REAL, DIMENSION(klon, klev, naero_grp, 2), INTENT(IN) :: piz_aero
+    REAL, DIMENSION(klon, klev, naero_grp, 2), INTENT(IN) :: cg_aero
+    CHARACTER(len = 4), DIMENSION(naero_grp), INTENT(IN) :: rfname
+    REAL, DIMENSION(klon, klev, 2), INTENT(IN) :: ccm
     !... K.Emanuel
-    REAL,DIMENSION(klon,klev),INTENT(IN)     :: da
-    REAL,DIMENSION(klon,klev,klev),INTENT(IN):: phi
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: da
+    REAL, DIMENSION(klon, klev, klev), INTENT(IN) :: phi
     ! RomP >>>
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: d1a,dam
-    REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi2
-    !
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: wdtrainA
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: wdtrainM
-    REAL,DIMENSION(klon),INTENT(IN)           :: sigd
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: d1a, dam
+    REAL, DIMENSION(klon, klev, klev), INTENT(IN) :: phi2
+    !
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: wdtrainA
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: wdtrainM
+    REAL, DIMENSION(klon), INTENT(IN) :: sigd
     ! ---- RomP flux entraine, detraine et precipitant kerry Emanuel
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: evap
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: ep
-    REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd          !RL
-    REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij
-    REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: eplaMm
-    REAL,DIMENSION(klon,klev),INTENT(IN)      :: clw
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: evap
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: ep
+    REAL, DIMENSION(klon, klev, klev), INTENT(IN) :: sij
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: wght_cvfd          !RL
+    REAL, DIMENSION(klon, klev, klev), INTENT(IN) :: elij
+    REAL, DIMENSION(klon, klev, klev), INTENT(IN) :: epmlmMm
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: eplaMm
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: clw
     ! RomP <<<
     !
-    REAL,DIMENSION(klon,klev),INTENT(IN)     :: mp
-    REAL,DIMENSION(klon,klev),INTENT(IN)     :: upwd      ! saturated updraft mass flux
-    REAL,DIMENSION(klon,klev),INTENT(IN)     :: dnwd      ! saturated downdraft mass flux
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: mp
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: upwd      ! saturated updraft mass flux
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: dnwd      ! saturated downdraft mass flux
     !
     !Thermiques:
     !----------
-    REAL,DIMENSION(klon,klev+1),INTENT(IN)   :: fm_therm
-    REAL,DIMENSION(klon,klev),INTENT(INOUT)     :: entr_therm
+    REAL, DIMENSION(klon, klev + 1), INTENT(IN) :: fm_therm
+    REAL, DIMENSION(klon, klev), INTENT(INOUT) :: entr_therm
     !
     !Couche limite:
     !--------------
     !
-    REAL,DIMENSION(:),INTENT(IN)   :: cdragh          ! (klon) coeff drag pour T et Q
-    REAL,DIMENSION(:,:),INTENT(IN) :: coefh           ! (klon,klev) coeff melange CL (m**2/s)
-    REAL,DIMENSION(:),INTENT(IN)   :: ustar,u10m,v10m ! (klon) u* & vent a 10m (m/s)
-    REAL,DIMENSION(:),INTENT(IN)   :: wstar,ale_bl,ale_wake ! (klon) w* and Avail. Lifting Ener.
-    REAL,DIMENSION(:),INTENT(IN)   :: yu1             ! (klon) vents au premier niveau
-    REAL,DIMENSION(:),INTENT(IN)   :: yv1             ! (klon) vents au premier niveau
+    REAL, DIMENSION(:), INTENT(IN) :: cdragh          ! (klon) coeff drag pour T et Q
+    REAL, DIMENSION(:, :), INTENT(IN) :: coefh           ! (klon,klev) coeff melange CL (m**2/s)
+    REAL, DIMENSION(:), INTENT(IN) :: ustar, u10m, v10m ! (klon) u* & vent a 10m (m/s)
+    REAL, DIMENSION(:), INTENT(IN) :: wstar, ale_bl, ale_wake ! (klon) w* and Avail. Lifting Ener.
+    REAL, DIMENSION(:), INTENT(IN) :: yu1             ! (klon) vents au premier niveau
+    REAL, DIMENSION(:), INTENT(IN) :: yv1             ! (klon) vents au premier niveau
     !
     !Lessivage:
@@ -270,26 +269,24 @@
     REAL, DIMENSION(:), ALLOCATABLE, SAVE :: coefcoli
     LOGICAL, DIMENSION(:), ALLOCATABLE, SAVE :: flag_cvltr
-!$OMP THREADPRIVATE(ccntrAA,ccntrENV,coefcoli,flag_cvltr)
-    REAL, DIMENSION(klon,klev) :: ccntrAA_3d
-    REAL, DIMENSION(klon,klev) :: ccntrENV_3d
-    REAL, DIMENSION(klon,klev) :: coefcoli_3d
+    !$OMP THREADPRIVATE(ccntrAA,ccntrENV,coefcoli,flag_cvltr)
+    REAL, DIMENSION(klon, klev) :: ccntrAA_3d
+    REAL, DIMENSION(klon, klev) :: ccntrENV_3d
+    REAL, DIMENSION(klon, klev) :: coefcoli_3d
     !
     ! pour le ON-LINE
     !
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: frac_impa ! fraction d'aerosols non impactes
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: frac_nucl ! fraction d'aerosols non nuclees
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: frac_impa ! fraction d'aerosols non impactes
+    REAL, DIMENSION(klon, klev), INTENT(IN) :: frac_nucl ! fraction d'aerosols non nuclees
 
     ! Arguments necessaires pour les sources et puits de traceur:
-    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: ftsol  ! Temperature du sol (surf)(Kelvin)
-    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: pctsrf ! Pourcentage de sol (nature du sol)
-
-#ifdef CPP_StratAer
-    REAL,DIMENSION(klon)           :: v_dep_dry !dry deposition velocity of stratospheric sulfate in m/s
-#endif
+    REAL, DIMENSION(klon, nbsrf), INTENT(IN) :: ftsol  ! Temperature du sol (surf)(Kelvin)
+    REAL, DIMENSION(klon, nbsrf), INTENT(IN) :: pctsrf ! Pourcentage de sol (nature du sol)
+
+    REAL, DIMENSION(klon) :: v_dep_dry !dry deposition velocity of stratospheric sulfate in m/s
     ! Output argument
     !----------------
-    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT) :: tr_seri ! Concentration Traceur [U/KgA]
-    REAL,DIMENSION(klon,klev)                    :: sourceBE 
-    REAL,DIMENSION(klon,nbtr), INTENT(IN) :: init_source
+    REAL, DIMENSION(klon, klev, nbtr), INTENT(INOUT) :: tr_seri ! Concentration Traceur [U/KgA]
+    REAL, DIMENSION(klon, klev) :: sourceBE
+    REAL, DIMENSION(klon, nbtr), INTENT(IN) :: init_source
 
     !=======================================================================================
@@ -303,64 +300,64 @@
     !--------------------------------------------
     !
-    REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: source  ! a voir lorsque le flux de surface est prescrit
-!$OMP THREADPRIVATE(source)
+    REAL, DIMENSION(:, :), ALLOCATABLE, SAVE :: source  ! a voir lorsque le flux de surface est prescrit
+    !$OMP THREADPRIVATE(source)
 
     !
     !Entrees/Sorties:
     !---------------
-    INTEGER                   :: iiq, ierr
-    INTEGER                   :: nhori, nvert
-    REAL                      :: zsto, zout, zjulian
-    INTEGER,SAVE              :: nid_tra     ! pointe vers le fichier histrac.nc         
-!$OMP THREADPRIVATE(nid_tra)
-    REAL,DIMENSION(klon)      :: zx_tmp_fi2d ! variable temporaire grille physique
-    INTEGER                   :: itau_w      ! pas de temps ecriture = nstep + itau_phy
-    LOGICAL,PARAMETER         :: ok_sync=.TRUE.
+    INTEGER :: iiq, ierr
+    INTEGER :: nhori, nvert
+    REAL :: zsto, zout, zjulian
+    INTEGER, SAVE :: nid_tra     ! pointe vers le fichier histrac.nc
+    !$OMP THREADPRIVATE(nid_tra)
+    REAL, DIMENSION(klon) :: zx_tmp_fi2d ! variable temporaire grille physique
+    INTEGER :: itau_w      ! pas de temps ecriture = nstep + itau_phy
+    LOGICAL, PARAMETER :: ok_sync = .TRUE.
     !
     ! Nature du traceur
     !------------------
-    LOGICAL,DIMENSION(:),ALLOCATABLE,SAVE :: aerosol  ! aerosol(it) = true  => aerosol => lessivage
-!$OMP THREADPRIVATE(aerosol)                        ! aerosol(it) = false => gaz
-    REAL,DIMENSION(klon,klev)             :: delp     ! epaisseur de couche (Pa)
+    LOGICAL, DIMENSION(:), ALLOCATABLE, SAVE :: aerosol  ! aerosol(it) = true  => aerosol => lessivage
+    !$OMP THREADPRIVATE(aerosol)                        ! aerosol(it) = false => gaz
+    REAL, DIMENSION(klon, klev) :: delp     ! epaisseur de couche (Pa)
     !
     ! Tendances de traceurs (Td) et flux de traceurs:
     !------------------------
-    REAL,DIMENSION(klon,klev)      :: d_tr     ! Td dans l'atmosphere
-    REAL,DIMENSION(klon,klev)      :: Mint
-    REAL,DIMENSION(klon,klev,nbtr) :: zmfd1a
-    REAL,DIMENSION(klon,klev,nbtr) :: zmfdam
-    REAL,DIMENSION(klon,klev,nbtr) :: zmfphi2
+    REAL, DIMENSION(klon, klev) :: d_tr     ! Td dans l'atmosphere
+    REAL, DIMENSION(klon, klev) :: Mint
+    REAL, DIMENSION(klon, klev, nbtr) :: zmfd1a
+    REAL, DIMENSION(klon, klev, nbtr) :: zmfdam
+    REAL, DIMENSION(klon, klev, nbtr) :: zmfphi2
     ! Physique
-    !---------- 
-    REAL,DIMENSION(klon,klev,nbtr) :: flestottr ! flux de lessivage dans chaque couche 
-    REAL,DIMENSION(klon,klev)      :: zmasse    ! densite atmospherique Kg/m2
-    REAL,DIMENSION(klon,klev)      :: ztra_th
+    !----------
+    REAL, DIMENSION(klon, klev, nbtr) :: flestottr ! flux de lessivage dans chaque couche
+    REAL, DIMENSION(klon, klev) :: zmasse    ! densite atmospherique Kg/m2
+    REAL, DIMENSION(klon, klev) :: ztra_th
     !PhH
-    REAL,DIMENSION(klon,klev)      :: zrho
-    REAL,DIMENSION(klon,klev)      :: zdz
-    REAL                           :: evaplsc,dx,beta ! variable pour lessivage Genthon
-    REAL,DIMENSION(klon)           :: his_dh          ! ---
+    REAL, DIMENSION(klon, klev) :: zrho
+    REAL, DIMENSION(klon, klev) :: zdz
+    REAL :: evaplsc, dx, beta ! variable pour lessivage Genthon
+    REAL, DIMENSION(klon) :: his_dh          ! ---
     ! in-cloud scav variables
-    REAL           :: ql_incloud_ref     ! ref value of in-cloud condensed water content
+    REAL :: ql_incloud_ref     ! ref value of in-cloud condensed water content
 
     !Controles:
     !---------
-    INTEGER,SAVE :: iflag_vdf_trac,iflag_con_trac,iflag_the_trac
-    INTEGER,SAVE  :: iflag_con_trac_omp, iflag_vdf_trac_omp,iflag_the_trac_omp
-!$OMP THREADPRIVATE(iflag_vdf_trac,iflag_con_trac,iflag_the_trac)
-
-    LOGICAL,SAVE :: lessivage
-!$OMP THREADPRIVATE(lessivage)
+    INTEGER, SAVE :: iflag_vdf_trac, iflag_con_trac, iflag_the_trac
+    INTEGER, SAVE :: iflag_con_trac_omp, iflag_vdf_trac_omp, iflag_the_trac_omp
+    !$OMP THREADPRIVATE(iflag_vdf_trac,iflag_con_trac,iflag_the_trac)
+
+    LOGICAL, SAVE :: lessivage
+    !$OMP THREADPRIVATE(lessivage)
 
     !RomP >>>
-    INTEGER,SAVE  :: iflag_lscav_omp,iflag_lscav
-    REAL, SAVE ::   ccntrAA_in,ccntrAA_omp
-    REAL, SAVE ::   ccntrENV_in,ccntrENV_omp
-    REAL, SAVE ::   coefcoli_in,coefcoli_omp
-
-    LOGICAL,SAVE  :: convscav_omp,convscav
-!$OMP THREADPRIVATE(iflag_lscav)
-!$OMP THREADPRIVATE(ccntrAA_in,ccntrENV_in,coefcoli_in)
-!$OMP THREADPRIVATE(convscav)
+    INTEGER, SAVE :: iflag_lscav_omp, iflag_lscav
+    REAL, SAVE :: ccntrAA_in, ccntrAA_omp
+    REAL, SAVE :: ccntrENV_in, ccntrENV_omp
+    REAL, SAVE :: coefcoli_in, coefcoli_omp
+
+    LOGICAL, SAVE :: convscav_omp, convscav
+    !$OMP THREADPRIVATE(iflag_lscav)
+    !$OMP THREADPRIVATE(ccntrAA_in,ccntrENV_in,coefcoli_in)
+    !$OMP THREADPRIVATE(convscav)
     !RomP <<<
     !######################################################################
